## openturns 1.5

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required ( VERSION 2.8 )

# By default, build in Release mode. Must appear before project() command
if ( NOT DEFINED CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Build type" )
endif ()
if (CMAKE_VERSION VERSION_GREATER 2.8)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
endif ()

project ( OpenTURNS CXX )

option ( USE_BISON                    "Looks for Bison if true and then build parser"                         ON )
option ( USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON )
option ( USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON )
option ( USE_SYSTEM_LAPACK            "Use system LAPACK libraries"                                           ON )

# still a bit new: provided by 3.5.0 but the cmake config file is only in the dev version
option ( USE_LAPACKE                  "Use LAPACKE C interface to LAPACK"                                     OFF )

option ( USE_HMAT                     "Use HMat library"                                                      ON )
option ( USE_MUPARSER                 "Use muParser libraries"                                                ON )
option ( USE_MUPARSER2                "Use muParser2 features"                                                OFF )
option ( USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON )
option ( USE_R                        "Use R for graph output support"                                        ON )
option ( USE_OPENMP                   "Use OpenMP for multithreading"                                         OFF )
option ( USE_BOOST                    "Use Boost for distribution computation"                                ON )
option (USE_SPHINX                    "Use sphinx for documentation"                                          ON)

option ( BUILD_LIB                    "Build the library"                                                     ON )
option ( BUILD_PYTHON                 "Build the python module for the library"                               ON )
option ( BUILD_VALIDATION             "Build the validation files of the library"                             ON )
option ( LINK_PYTHON_LIBRARY          "Link python modules against python library"                            ON )
option ( INSTALL_TESTS                "Install compiled tests for native platform testing"                    OFF )
option ( BUILD_SHARED_LIBS            "Build shared libraries"                                                ON )

if ( MSVC )
  option ( BUILD_MULTIPROCESSOR       "Enable multiprocessor builds"                                          ON )
endif ()

# Defines our own module path
list ( APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake )


set ( OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME     )

if ( NOT DEFINED CMAKE_INSTALL_LIBDIR )
  set ( CMAKE_INSTALL_LIBDIR lib${LIB_SUFFIX} )
endif ()

set ( OPENTURNS_LIBRARY_PATH
      ${CMAKE_INSTALL_LIBDIR}
      CACHE PATH "The directory where the library is installed"
    )
set ( OPENTURNS_INCLUDE_PATH
      include/openturns
      CACHE PATH "The directory where the header files are installed"
    )
set ( OPENTURNS_CONFIG_CMAKE_PATH
      ${CMAKE_INSTALL_LIBDIR}/cmake/openturns
      CACHE PATH "The directory where the CMake files are installed"
    )
set ( OPENTURNS_SYSCONFIG_PATH
      etc
      CACHE PATH "The directory where the configuration file is installed"
    )
set ( OPENTURNS_DATA_PATH
      share
      CACHE PATH "The directory where the common files are installed"
    )
set ( OPENTURNS_WRAPPER_PATH
      ${CMAKE_INSTALL_LIBDIR}/openturns/wrappers
      CACHE PATH "The directory where the wrapper files are installed"
    )
set ( OPENTURNS_EXAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the example files are installed"
    )
set ( OPENTURNS_SAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the sample files are installed"
    )
set ( OPENTURNS_VALIDATION_PATH
      share/openturns/validation
      CACHE PATH "The directory where validation files are installed"
    )
set ( OPENTURNS_DOC_PATH
      share/openturns/doc
      CACHE PATH "The directory where the license files are installed"
    )

if ( WIN32 )
  set ( DEFAULT_TMP TEMP )
  set ( PATH_SEP "\\;" )
else ()
  set( DEFAULT_TMP /tmp )
  set ( PATH_SEP ":" )
endif()

set ( OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
    )
set ( TEMPDIR ${OPENTURNS_TEMPDIR} )

# WARNING: This is where variables without OPENTURNS_ prefix are defined !
foreach ( _var INSTALL_PATH LIBRARY_PATH INCLUDE_PATH CONFIG_CMAKE_PATH SYSCONFIG_PATH DATA_PATH WRAPPER_PATH EXAMPLE_PATH SAMPLE_PATH VALIDATION_PATH DOC_PATH )
  file ( TO_NATIVE_PATH "${OPENTURNS_${_var}}" NATIVE_OPENTURNS_${_var} )
  if ( NOT IS_ABSOLUTE ${NATIVE_OPENTURNS_${_var}} )
    file ( TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/${OPENTURNS_${_var}} NATIVE_OPENTURNS_${_var} )
  endif ()
  string(REPLACE "\\" "\\\\" ${_var} ${NATIVE_OPENTURNS_${_var}})
endforeach ( _var )

# CMake 2.x does not define MSVC when using Intel compiler on Windows, see
# http://public.kitware.com/Bug/view.php?id=14476
if ( WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel" )
  set(WINTEL TRUE)
endif()


if ( BUILD_LIB )

enable_language ( C )

if ( USE_SYSTEM_LAPACK )
  if ( USE_LAPACKE )
    find_package ( LAPACKE NO_MODULE )
    if (LAPACKE_FOUND)
      set (OPENTURNS_HAVE_LAPACKE TRUE)
      list (APPEND OPENTURNS_INCLUDE_DIRS ${LAPACKE_INCLUDE_DIRS})
      list (APPEND OPENTURNS_LIBRARIES ${LAPACKE_LIBRARIES})
    endif ()
  endif ()
  if ( NOT LAPACKE_FOUND )
    enable_language( Fortran )
    find_package ( LAPACK REQUIRED )
    if (LAPACK_FOUND)
      list (APPEND OPENTURNS_LIBRARIES ${LAPACK_LIBRARIES})
    endif ()
  endif ()
endif ()
if ( NOT LAPACK_FOUND AND NOT LAPACKE_FOUND )
  include ( ExternalProject )
  enable_language( Fortran )
  set ( LAPACK_PREFIX ${CMAKE_CURRENT_BINARY_DIR}/lapack-prefix )
  ExternalProject_Add ( lapack
    URL http://www.netlib.org/lapack/lapack-3.5.0.tgz
    URL_MD5 b1d3e3e425b2e44a06760ff173104bdf
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${LAPACK_PREFIX}
      -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
      -DBUILD_TESTING=OFF
      "-DCMAKE_Fortran_FLAGS=-g -O2 -fPIC"
  )
  list ( APPEND OPENTURNS_PRIVATE_LIBRARIES ${LAPACK_PREFIX}/lib/libblas.a )
  list ( APPEND OPENTURNS_PRIVATE_LIBRARIES ${LAPACK_PREFIX}/lib/liblapack.a )
endif ()



if ( USE_BISON )
  find_package ( BISON 2.4 )
  if ( BISON_FOUND )
    set ( OPENTURNS_HAVE_BISON TRUE )
  endif ()
endif ()

if ( USE_FLEX )
  find_package ( FLEX )
  if ( FLEX_FOUND )
    set ( OPENTURNS_HAVE_FLEX TRUE )
  endif ()
endif ()

find_program ( BC_EXECUTABLE NAMES bc )

if ( USE_TBB )
  find_package ( TBB )
  if (TBB_FOUND)
    set (OPENTURNS_HAVE_TBB_TBB_H TRUE)
    set (OPENTURNS_HAVE_TBB TRUE)
    list (APPEND OPENTURNS_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
    list (APPEND OPENTURNS_LIBRARIES ${TBB_LIBRARIES})
    if (MSVC OR WINTEL)
      set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
    endif ()
  endif ()
endif ()

if ( USE_MUPARSER )
  find_package ( muParser 1.32 )
  if (MUPARSER_FOUND)
    set (OPENTURNS_HAVE_MUPARSER TRUE)
    list (APPEND OPENTURNS_LIBRARIES ${MUPARSER_LIBRARIES})
    list (APPEND OPENTURNS_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
    if (USE_MUPARSER2 AND NOT MUPARSER_VERSION_STRING VERSION_LESS 2)
      set (OPENTURNS_HAVE_MUPARSER2 TRUE)
    endif ()
  endif ()
endif ()

if ( USE_HMAT )
  find_package (HMAT NO_MODULE)
  if (HMAT_FOUND)
    set (OPENTURNS_HAVE_HMAT TRUE)
    list (APPEND OPENTURNS_LIBRARIES ${HMAT_LIBRARIES})
    list (APPEND OPENTURNS_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
  endif ()
endif ()

find_package ( Doxygen )

if ( USE_LIBXML2 )
  find_package ( LibXml2 )
  if (LIBXML2_FOUND)
    set (OPENTURNS_HAVE_LIBXML2 TRUE)
    list ( APPEND OPENTURNS_DEFINITIONS ${LIBXML2_DEFINITIONS} )
    list ( APPEND OPENTURNS_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR} )
    list ( APPEND OPENTURNS_LIBRARIES ${LIBXML2_LIBRARIES} )
  endif ()
endif ()

if (MSVC OR WINTEL)
  set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${CMAKE_CURRENT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
  include_directories (${PROJECT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
endif ()
find_package ( Threads )
if (Threads_FOUND)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${THREADS_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif ()

find_package ( Libdl )
if (LIBDL_FOUND)
  set (OPENTURNS_HAVE_LIBDL TRUE)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${LIBDL_INCLUDE_DIR})
  list (APPEND OPENTURNS_LIBRARIES ${LIBDL_LIBRARIES})
endif ()

find_package ( Regex )
if (REGEX_FOUND)
  set (OPENTURNS_HAVE_REGEX TRUE )
  list (APPEND OPENTURNS_INCLUDE_DIRS ${REGEX_INCLUDE_DIR})
  list (APPEND OPENTURNS_LIBRARIES ${REGEX_LIBRARIES})
endif ()

if (MSVC OR WINTEL)
  set (BOOST_REQUIRED_ARG REQUIRED)
  set (USE_BOOST ON CACHE INTERNAL "Force use of Boost on Windows")
endif ()
if ( USE_BOOST )
  # doesn't pass all tests with boost <=1.42 (debian6)
  # but at least pass with 1.46 (ubuntu precise)
  find_package ( Boost 1.46 ${BOOST_REQUIRED_ARG})
  if (Boost_FOUND)
    set (OPENTURNS_HAVE_BOOST TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
  endif ()
endif ()

if ( USE_R )
  find_package ( R COMPONENTS base rot )
endif ()

if ( USE_OPENMP )
  find_package ( OpenMP )
  if (OPENMP_FOUND)
    set ( CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}" )
  endif ()
endif ()

if ( MSVC )
  if ( BUILD_MULTIPROCESSOR )
    set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP" )
  endif ()
  # Disable some warnings
  set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4197 /wd4244 /wd4251 /wd4267 /wd4996" )
endif ()

include ( TestBigEndian )
test_big_endian ( __BIG_ENDIAN__ ) 

try_compile(OPENTURNS_UNSIGNEDLONG_SAME_AS_UINT64
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/unsignedlong_same_as_uint64_t.cxx )

# Find system prerequisites
include ( CheckIncludeFile )
check_include_file ( assert.h      OPENTURNS_HAVE_ASSERT_H      )
check_include_file ( dirent.h      OPENTURNS_HAVE_DIRENT_H      )
check_include_file ( errno.h       OPENTURNS_HAVE_ERRNO_H       )
check_include_file ( inttypes.h    OPENTURNS_HAVE_INTTYPES_H    )
check_include_file ( malloc.h      OPENTURNS_HAVE_MALLOC_H      )
check_include_file ( math.h        OPENTURNS_HAVE_MATH_H        )
check_include_file ( pthread.h     OPENTURNS_HAVE_PTHREAD_H     )
check_include_file ( regex.h       OPENTURNS_HAVE_REGEX_H       )
check_include_file ( gnuregex.h    OPENTURNS_HAVE_GNUREGEX_H    )
check_include_file ( signal.h      OPENTURNS_HAVE_SIGNAL_H      )
check_include_file ( stdbool.h     OPENTURNS_HAVE_STDBOOL_H     )
check_include_file ( stdint.h      OPENTURNS_HAVE_STDINT_H      )
check_include_file ( stdlib.h      OPENTURNS_HAVE_STDLIB_H      )
check_include_file ( string.h      OPENTURNS_HAVE_STRING_H      )
check_include_file ( strings.h     OPENTURNS_HAVE_STRINGS_H     )
check_include_file ( sys/stat.h    OPENTURNS_HAVE_SYS_STAT_H    )
check_include_file ( sys/time.h    OPENTURNS_HAVE_SYS_TIME_H    )
check_include_file ( sys/types.h   OPENTURNS_HAVE_SYS_TYPES_H   )
check_include_file ( sys/un.h      OPENTURNS_HAVE_SYS_UN_H      )
check_include_file ( unistd.h      OPENTURNS_HAVE_UNISTD_H      )

else ()
  find_package ( OpenTURNS NO_MODULE REQUIRED )
endif ()

# Some useful macros to ease CMakeLists.txt file writing
set ( SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_source_file FILENAME )
