=== DESCRIPTION ===
Package: rot
Type: Package
Title: Statistical functions needed by the OpenTURNS project, see www.openturns.org
Version: 1.4.4
Date: 2008-10-26
Author: P.M. Pair, R. Lebrun
Maintainer: <bug@openturns.org>
Description: this R package is part of the OpenTURNS project, an Open Source platform for the Treatment of Uncertainty, Risk aNd Statistics. It provides an implementation of some of the statistical facilities provided by OpenTURNS.
License: GPL
Packaged: Sun Oct  26 16:47:55 2008; regis
