=== debian/changelog ===
openturns (1.5-7build2) xenial; urgency=medium

  * No-change rebuild for python3 defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Oct 2015 10:42:20 +0000

openturns (1.5-7build1) wily; urgency=medium

  * No-change rebuild against libhmat-oss1v5.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 12 Aug 2015 08:25:16 +0200

openturns (1.5-7) unstable; urgency=medium

  * debian/patches/randommixture-x86.patch: Fix Python tests,
    they are also failing on x86.

 -- Denis Barbier <barbier@debian.org>  Sat, 23 May 2015 13:57:25 +0100

openturns (1.5-6) unstable; urgency=medium

  * debian/patches/randommixture-x86.patch: Rewrite patch, there
    were still failures with RandomMixture_grid3d.

 -- Denis Barbier <barbier@debian.org>  Thu, 21 May 2015 20:48:55 +0100

openturns (1.5-5) unstable; urgency=medium

  * debian/patches/tests-fix-precision-32bits.patch: Modify test
    to really fix tests failures on ARM 32bits.
  * debian/patches/randommixture-x86.patch: New patch to fix
    tests failures on i386.

 -- Denis Barbier <barbier@debian.org>  Wed, 20 May 2015 20:34:39 +0100

openturns (1.5-4) unstable; urgency=medium

  * debian/rules: add --no-diffs option to 2to3.
  * debian/rules: less verbose tests output.
  * debian/patches/tests-fix-precision-32bits.patch:
    New patch to avoid tests failures on 32 bits systems.

 -- Denis Barbier <barbier@debian.org>  Tue, 19 May 2015 21:17:40 +0100

openturns (1.5-3) unstable; urgency=medium

  * Upload into unstable.
  * debian/control: Readd Build-Depends: gfortran to fix
    build failures.

 -- Denis Barbier <barbier@debian.org>  Mon, 11 May 2015 21:05:11 +0100

openturns (1.5-2) experimental; urgency=medium

  *  Merge python-openturns-dev into lib-openturns-dev.
  *  Add a versioned dependency on swig to ensure that
      backports work properly.

 -- Denis Barbier <barbier@debian.org>  Fri, 01 May 2015 14:27:55 +0100

openturns (1.5-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.
  * Updated debian/patches/tests-disable-coupling_tools.patches

  [ Denis Barbier ]
  * Rename libopenturns-dbg package into libopenturns0.6-dbg.
  * New python3-openturns binary package.
  * debian/control: Bump Standards-Version to 3.9.6, no changes
    are needed.

 -- Denis Barbier <barbier@debian.org>  Tue, 28 Apr 2015 21:46:44 +0200

openturns (1.5~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.
  * Add build-dependency to libhmat-oss-dev
  * Upstreamed libOT-gdb.py

 -- Denis Barbier <barbier@debian.org>  Wed, 10 Dec 2014 10:34:47 +0100

openturns (1.4-3) experimental; urgency=medium

  * debian/rules: Disable again mips and mipsel builds.
    Mipsel failed to build, and mips did not even try.

 -- Denis Barbier <barbier@debian.org>  Sat, 23 Aug 2014 00:37:17 +0200

openturns (1.4-2) experimental; urgency=medium

  * modify-tests-O0-i386.patch: Patch dropped; with newer gcc,
    t_TrapezoidalFactory_std now gives the same result on *-i386
    architectures as on other.
  * debian/libOT-gdb.py: Make it compatible with python3.  Closes: #752663
    Report and patch by Matthias Klose, thanks.
  * debian/rules: Re-enable mips and mipsel builds.  Closes: #753594
    Report and patch by Dejan Latinovic, thanks.

 -- Denis Barbier <barbier@debian.org>  Wed, 13 Aug 2014 10:20:28 +0200

openturns (1.4-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.
  * tests-disable-broken-R.patch: Patch dropped, a fix has been
    applied upstream.
  * debian/control: Build Python bindings with -j1

  [ Denis Barbier ]
  * debian/copyright: Updated.

 -- Denis Barbier <barbier@debian.org>  Fri, 25 Jul 2014 18:34:34 +0200

openturns (1.4~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.
  * Set CMAKE_INSTALL_LIBDIR overriden by Ubuntu

 -- Denis Barbier <barbier@debian.org>  Wed, 02 Jul 2014 10:34:47 +0200
