=== debian/watch ===
version=3
http://sf.net/openturns/openturns-([\d.]+)\.tar\.bz2
